unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset, Forms, Controls, Graphics, Dialogs,
  DBGrids, Grids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure DBGrid1PrepareCanvas(sender: TObject; DataCol: Integer;
      Column: TColumn; AState: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  FIRST_NAMES: array[0..5] of string = ('Otto', 'Hans', 'Willi', 'Maria', 'Julia', 'Anna');
  LAST_NAMES: array[0..5] of string = ('Bauer', 'Müller', 'Meier', 'Schneider', 'Metzger', 'Jäger');
  CITIES: array[0..5] of string = ('Köln', 'Hamburg', 'Berlin', 'München', 'Düsseldorf', 'Bremen');
  STREETS: array[0..4] of string = ('Hauptstraße', 'Lindenweg', 'Ulmen-Allee', 'Meisenplatz', 'Rosensteig');

type
  TMyDBGrid = class(TDBGrid);


{ TForm1 }

procedure TForm1.DBGrid1PrepareCanvas(sender: TObject; DataCol: Integer;
  Column: TColumn; AState: TGridDrawState);
var
  ts: TTextStyle;
begin
  ts := DBGrid1.Canvas.TextStyle;
  ts.WordBreak := true;
  ts.SingleLine := false;
  DBGrid1.Canvas.TextStyle := ts;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  BufDataset1.FileName := 'test.db';
  if not FileExists(BufDataset1.FileName) then
  begin
    BufDataset1.FieldDefs.Clear;
    BufDataset1.FieldDefs.Add('Name', ftString, 20);
    BufDataset1.FieldDefs.Add('Adresse', ftstring, 50);
    BufDataset1.CreateDataset;

    BufDataset1.DisableControls;
    for i := 1 to 10 do begin
      BufDataset1.Append;
      BufDataset1.FieldByName('Name').AsString := Format('%s, %s', [
        LAST_NAMES[Random(Length(LAST_NAMES))],
        FIRST_NAMES[Random(Length(FIRST_NAMES))]
      ]);
      BufDataset1.FieldByName('Adresse').AsString := Format('%s %d, %s', [
        STREETS[Random(Length(STREETS))],
        Random(100) + 1,
        CITIES[Random(Length(CITIES))]
      ]);
      BufDataset1.Post;
    end;
  end else
    BufDataset1.Open;

  DBGrid1.AutoFillColumns := true;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
{
  // RICHTIG:
  // Zuerst DefaultRowHeight, dann einzelne Zeilenhöhe
  DBGrid1.DefaultRowHeight := 40;
  TMyDBGrid(DBGrid1).RowHeights[0] := 20;
}

  // FALSCH:
  // Zuerst einzelne Zeilenhöhe, dann DefaultRowHeight
  TMyDBGrid(DBGrid1).RowHeights[0] := 20;
  DBGrid1.DefaultRowHeight := 40;

end;

end.

